#define EX1_C

#include "main.h"



#define UPDATE_SECS 8

#define FD_SZ 128

static unsigned int offs[FD_SZ];

static unsigned int add_write(void)
{
 int fd = open("/dev/null", O_WRONLY);
 unsigned int ret = 0;

 if (fd  == -1)
 {
  fprintf(stderr, " Err: %d %s\n", errno, strerror(errno));
  exit (1);
 }

 fprintf(stdout, "write: open(%d)\n", fd);

 ret = socket_poll_add(fd);
 if (!ret)
   exit (10);

 if (rand() & 4)
   SOCKET_POLL_INDICATOR(ret)->events = POLLOUT;

 return (ret);
}

static unsigned int add_read(void)
{
 int fd = open("ex1.c", O_RDONLY);
 unsigned int ret = 0;
 
 if (fd  == -1)
 {
  fprintf(stderr, " Err: %d %s\n", errno, strerror(errno));
  exit (1);
 }

 fprintf(stdout, "read:  open(%d)\n", fd);

 ret = socket_poll_add(fd);
 if (!ret)
   exit (8);

 if (rand() & 4)
   SOCKET_POLL_INDICATOR(ret)->events = POLLIN;
 
 return (ret);
}

static void setup(void)
{
 unsigned int count = 0;

 while (count < FD_SZ)
 {
  offs[count] = add_write();
  
  ++count;
 }
}

static void go_through_polls(void)
{
 unsigned int count = 0;

 while (count < FD_SZ)
 {
  char buffer[256] = "abcd\n";
  ssize_t len = 0;

  if (offs[count])
  {
   if (SOCKET_POLL_INDICATOR(offs[count])->revents & (POLLERR|POLLHUP|POLLNVAL))
   {
    fprintf(stdout, "inval %d\n", SOCKET_POLL_INDICATOR(offs[count])->fd);
    close(SOCKET_POLL_INDICATOR(offs[count])->fd);
    socket_poll_del(offs[count]);
    offs[count] = 0;
   }
   else if (SOCKET_POLL_INDICATOR(offs[count])->revents & POLLIN)
   {
    len = read(SOCKET_POLL_INDICATOR(offs[count])->fd, buffer, sizeof(buffer));
    if (len == -1)
    {
     if (errno == EBADF)
       fprintf(stdout, "EBADF: read(%d)\n", SOCKET_POLL_INDICATOR(offs[count])->fd);
     else
       fprintf(stdout, "%d: read(%d)\n", errno, SOCKET_POLL_INDICATOR(offs[count])->fd);
     close(SOCKET_POLL_INDICATOR(offs[count])->fd);
     socket_poll_del(offs[count]);
     offs[count] = 0;
    }
    else if (len == 0)
    {
     fprintf(stdout, "done:  read(%d)\n", SOCKET_POLL_INDICATOR(offs[count])->fd);
     close(SOCKET_POLL_INDICATOR(offs[count])->fd);
     socket_poll_del(offs[count]);
     offs[count] = 0;
    }
   }
   else if (SOCKET_POLL_INDICATOR(offs[count])->revents & POLLOUT)
   {
    len = write(SOCKET_POLL_INDICATOR(offs[count])->fd, buffer, strlen(buffer));
    if (len == -1)
    {
     if (errno == EBADF)
       fprintf(stdout, "EBADF: write(%d)\n", SOCKET_POLL_INDICATOR(offs[count])->fd);
     else
       fprintf(stdout, "%d: write(%d)\n", errno, SOCKET_POLL_INDICATOR(offs[count])->fd);
     close(SOCKET_POLL_INDICATOR(offs[count])->fd);
     socket_poll_del(offs[count]);
     offs[count] = 0;
    }
   }
  }
  
  ++count;
 }
}

static void do_something(void)
{
 unsigned int count = 0;

 while (count < FD_SZ)
 {
  int ra = rand();
  
  if (!offs[count])
  {
   if (ra & 2)
   {
    if (ra & 4)
      offs[count] = add_write();
    else
      offs[count] = add_read();
   }
  }
  else if ((ra & 3) == 3)
  {
   if ((ra & 12) == 12)
   {
    fprintf(stdout, "done:  close(%d)\n", SOCKET_POLL_INDICATOR(offs[count])->fd);
    close(SOCKET_POLL_INDICATOR(offs[count])->fd);
    socket_poll_del(offs[count]);
    offs[count] = 0;
   }
   else if (0)
   {
    fprintf(stdout, "pre:  close(%d)\n", SOCKET_POLL_INDICATOR(offs[count])->fd);
    close(SOCKET_POLL_INDICATOR(offs[count])->fd);
   }
  }
  
  ++count;
 }
}

int main(void)
{
 socket_poll_init(0, SOCKET_POLL_TYPE_MAP_COMPRESSED);
 
 srand(getpid() ^ time(0));

 setup();
 
 while (1)
 {
  socket_poll_update_all(1000 * UPDATE_SECS);

  go_through_polls();

  if (rand() & 2)
    do_something();
 }

 exit (EXIT_SUCCESS);
}
