#define EX1_C

#include "main.h"


#if 0
# define GENFDS(x) socketpair(PF_LOCAL, SOCK_STREAM, IPPROTO_IP, x)
#else
# define GENFDS(x) pipe(x)
#endif

#define UPDATE_SECS 8

#define FD_SZ 10000

static unsigned int offs[FD_SZ];
static unsigned int offs_sz = 0;
 

static void go_through_polls(int ret)
{
 unsigned int count = 0;

 while ((count < offs_sz) && (ret > 0))
 {
  char buffer[256] = "abcd\n";
  ssize_t len = 0;

  if (offs[count])
  {
   if (SOCKET_POLL_INDICATOR(offs[count])->revents & (POLLERR|POLLHUP|POLLNVAL))
   {
    --ret;
    fprintf(stdout, "inval %d\n", SOCKET_POLL_INDICATOR(offs[count])->fd);
    close(SOCKET_POLL_INDICATOR(offs[count])->fd);
    socket_poll_del(offs[count]);
    offs[count] = 0;
   }
   else if (SOCKET_POLL_INDICATOR(offs[count])->revents & POLLIN)
   {
    --ret;
    len = read(SOCKET_POLL_INDICATOR(offs[count])->fd, buffer, sizeof(buffer));
    if (len == -1)
    {
     if (errno == EBADF)
       fprintf(stdout, "EBADF: read(%d)\n", SOCKET_POLL_INDICATOR(offs[count])->fd);
     else
       fprintf(stdout, "%d: read(%d)\n", errno, SOCKET_POLL_INDICATOR(offs[count])->fd);
     close(SOCKET_POLL_INDICATOR(offs[count])->fd);
     socket_poll_del(offs[count]);
     offs[count] = 0;
    }
    else if (len == 0)
    {
     fprintf(stdout, "done:  read(%d)\n", SOCKET_POLL_INDICATOR(offs[count])->fd);
     close(SOCKET_POLL_INDICATOR(offs[count])->fd);
     socket_poll_del(offs[count]);
     offs[count] = 0;
    }
    else if (1)
    {
     fprintf(stdout, "data(%u): read=%.*s\n", SOCKET_POLL_INDICATOR(offs[count])->fd, len, buffer);     
    }
   }
   else if (SOCKET_POLL_INDICATOR(offs[count])->revents & POLLOUT)
   {
    --ret;
    len = write(SOCKET_POLL_INDICATOR(offs[count])->fd, buffer, strlen(buffer));
    if (len == -1)
    {
     if (errno == EBADF)
       fprintf(stdout, "EBADF: write(%d)\n", SOCKET_POLL_INDICATOR(offs[count])->fd);
     else
       fprintf(stdout, "%d: write(%d)\n", errno, SOCKET_POLL_INDICATOR(offs[count])->fd);
     close(SOCKET_POLL_INDICATOR(offs[count])->fd);
     socket_poll_del(offs[count]);
     offs[count] = 0;
    }
   }
  }
  
  ++count;
 }
}

int main(void)
{
 int ret = 0;
 
 socket_poll_init(0, SOCKET_POLL_TYPE_MAP_COMPRESSED);
 
 offs[offs_sz] = socket_poll_add(0);
 if (!offs[offs_sz])
   exit (127);

 SOCKET_POLL_INDICATOR(offs[offs_sz])->events = POLLIN;
 
 while (1)
 {
  struct timeval timestamp_start;
  struct timeval timestamp_end;
  
  gettimeofday(&timestamp_start, NULL);
  
  if (0 && (ret == 0))
    ret = socket_poll_update_all(1000 * UPDATE_SECS);
  else
    ret = socket_poll_update_all(0);
  
  if (ret == -1)
  {
   fprintf(stderr, "poll: %d %s\n", errno, strerror(errno));
  }
  else if (ret == 0)
    continue;

  go_through_polls(ret);

  gettimeofday(&timestamp_end, NULL);

  /* doesn't work for "large" time diffs */
  while (timestamp_start.tv_sec < timestamp_end.tv_sec)
  {
   --timestamp_end.tv_sec;
   timestamp_end.tv_usec += 1000000;
  }
  
  fprintf(stdout, "Stats: sz=%d time=%lu\n",
          offs_sz + 1, timestamp_end.tv_usec - timestamp_start.tv_usec);
  
  if (offs_sz < (FD_SZ - 2))
  {
   int p[2];

   if (GENFDS(p) == -1)
   {
    fprintf(stderr, " Err: %d %s\n", errno, strerror(errno));
    exit (1);
   }

   offs[++offs_sz] = socket_poll_add(p[0]);
   if (!offs[offs_sz])
     exit (4);
   offs[++offs_sz] = socket_poll_add(p[1]);
   if (!offs[offs_sz])
     exit (8);
  }
 }

 exit (EXIT_SUCCESS);
}
