#! /bin/sh

if [ ! -r VERSION -o ! -r socket_poll.spec -o ! -r configure ]; then
 echo "No VERSION, socket_poll.spec or configure file."
 exit 1
fi

v="`cat VERSION`"
s="`pwd`"
cd ../build/socket_poll

rm -rf socket_poll-$v
cp -a $s ./socket_poll-$v
cd ./socket_poll-$v
./scripts/clean.sh

find . \
 \( -name "*.o" -o -name ".*[%~]" -o -name "*[%~]" -o -name "#*#" \) \
 -print0 | xargs --no-run-if-empty -0 rm -f

cp $s/socket_poll.spec .

cd ..

tar -cf socket_poll-$v.tar socket_poll-$v
bzip2 -9f socket_poll-$v.tar

tar -cf socket_poll-$v.tar socket_poll-$v
gzip -9f socket_poll-$v.tar

sudo rpmbuild -ta                  socket_poll-$v.tar.gz
sudo rpmbuild -tb --define 'dbg 1' socket_poll-$v.tar.gz

ls -aslF /usr/src/redhat/RPMS/*/socket_poll*-$v-*
ls -aslF /usr/src/redhat/SRPMS/socket_poll*-$v-*

