# Note that this is NOT a relocatable package
%define ver      1.0.1
%define libver  1.0
%define real_release_num 1
%define RELEASE %{real_release_num}
%define rel     %{?CUSTOM_RELEASE} %{!?CUSTOM_RELEASE:%RELEASE}
%define prefix   /usr
%define name socket_poll

%define dbg_opt %{?dbg}%{!?dbg:0}

%if %{dbg_opt}
%define debugopt --enable-debug
%define RELEASE %{real_release_num}debug
%else
%define debugopt %nil
%endif

%define devdoco %{_datadir}/doc/%{name}-devel-%{ver}

Summary: Handy library for polling on file descriptors
Name: socket_poll
Version: %ver
Release: %rel
Copyright: LGPL
Group: Development/Libraries
Source: ftp://ftp.and.org/pub/james/%{name}/%{ver}/%{name}-%{ver}.tar.gz
BuildRoot: /var/tmp/%{name}-%{PACKAGE_VERSION}-root
BuildRequires: pkgconfig >= 0.8, autoconf, automake, libtool
URL: http://www.and.org/socket_poll/
Packager: James Antill <james@and.org>

%description
 Handy library of functions for polling file descriptors. It's main advantages
are that it's faster than most implementations and it allows for transparent
usage by shared libraries.
 It's built on top of either poll() or select() depending on what you have on
your system.

 Development libs and headers are in %{name}-devel.


%package devel
Requires: pkgconfig >= 0.8
Requires: %{name} = %{version}
Summary: Support library for various applications/libraries.
Group: Development/Libraries

%description devel
 Static libraries and header files for the support library of various
applications and libraries, which are available as public libraries.
 Also includes a %{name}.pc file for pkg-config.

%changelog
* Thu Jan 16 2003 James Antill <james@and.org>
- Update rpm.spec stuff from vstr.spec

* Mon Apr 10 2000 James Antill <james@and.org>
- Hack a spec file.

%prep
%setup

%build
# For devel releases
if [ ! -f configure ]; then
  ./scripts/autogen.sh
fi

%configure --prefix=%{prefix} \
  --mandir=%{_mandir} --datadir=%{_datadir} \
  --libdir=%{_libdir} --includedir=%{_includedir}/%{name}-%{libver} \
  %{debugopt}

make

%install
rm -rf $RPM_BUILD_ROOT

make DESTDIR=$RPM_BUILD_ROOT install

cp TODO BUGS $RPM_BUILD_ROOT/%{devdoco}/
rm -f $RPM_BUILD_ROOT/usr/lib/lib%{name}.la

%clean
rm -rf $RPM_BUILD_ROOT

%post -p /sbin/ldconfig

%postun -p /sbin/ldconfig

%files
%defattr(-, root, root)

%doc AUTHORS COPYING ChangeLog NEWS README TODO

%{_libdir}/lib%{name}-%{libver}.so.*

%files devel
%defattr(-, root, root)

%{_libdir}/lib%{name}.so
%{_libdir}/lib%{name}.a
%{_libdir}/pkgconfig/%{name}.pc
%{_includedir}/%{name}-%{libver}/*.h

%doc
%{devdoco}/BUGS
%{devdoco}/TODO
%{devdoco}/functions.txt
%{devdoco}/functions.html
%{devdoco}/constants.txt
%{devdoco}/constants.html
%{devdoco}/namespace.txt
%{devdoco}/namespace.html
%{devdoco}/overview.html

